<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS\Commands;
use CMSMS\CLI\App;
use CMSMS\CLI\GetOptExt\Command;
use CMSMS\CLI\GetOptExt\Option;
use CMSMS\CLI\GetOptExt\GetOpt;
use GetOpt\Operand;
use mams_user_query;
use mams_user_query_opt;
use cms_utils;

class GroupViewCommand extends Command
{
    public function __construct( App $app )
    {
        parent::__construct( $app, 'mams-group-view' );
        $this->addOperand( new Operand( 'group', Operand::REQUIRED ) );
        $this->addOption( Option::Create('j','json')->setDescription('Adjust the group name'));
    }

    public function getShortDescription()
    {
        return 'Edit an FEU Group definition';
    }

    public function getLongDescription()
    {
        return 'Edit an FEU Group definition';
    }

    public function handle()
    {
        $group = trim($this->getOperand('group')->value());
        $json = $this->GetOption('json')->value();
        $required_vals = [ 0=>'off', 1=>'optional', 2=>'required', 3=>'hidden', 4=>'readonly' ];
        $mams = cms_utils::get_module(MOD_MAMS);
        $gid = $mams->GetGroupID( $group );
        if( $gid < 1 ) throw new \RuntimeException("Group $group not found");
        $ginfo = $mams->GetGroupInfo( $gid );
        $ginfo['description'] = $ginfo['groupdesc'];
        $ginfo['name'] = $ginfo['groupname'];
        $ginfo['count'] = (int) $ginfo['count'];
        unset($ginfo['groupdesc'], $ginfo['groupname']);

        $relns = $mams->GetGroupPropertyRelations( $gid );
        if( !empty($relns) ) {
            array_walk($relns,function(&$item) use ($required_vals) {
                    $item['lostunflag'] = (int) $item['lostunflag'];
                    $item['group_id'] = (int) $item['group_id'];
                    $item['sort_key'] = (int) $item['sort_key'];
                    $item['required'] = $required_vals[$item['required']];
                });
            usort($relns,function($a,$b){
                    if( $a['sort_key'] != $b['sort_key'] ) return $a['sort_key'] - $b['sort_key'];
                    return strcmp($a['name'],$b['name']);
            });
            $ginfo['properties'] = $relns;
        }

        if( $json ) {
            echo json_encode($ginfo,JSON_PRETTY_PRINT);
            return;
        }

        echo "ID: {$ginfo['id']}\n";
        echo "NAME: {$ginfo['name']}\n";
        echo "DESCRIPTION: {$ginfo['description']}\n";
        echo "MEMBERS: {$ginfo['count']}\n";
        if( $ginfo['properties' ] ) {
            $fmt = "PROPERTY: name=%s status=%s lostun=%d\n";
            foreach( $ginfo['properties'] as $row ) {
                printf($fmt, $row['name'], $row['required'], $row['lostunflag']);
            }
        }
    }
} // end of class.
